# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-List-SomeUtils
Version:	0.59
Release:	2.%{__distinit}%{__distvers}
Summary:	Provide the stuff missing in List::Util
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/List-SomeUtils
Source0:	https://cpan.metacpan.org/modules/by-module/List/List-SomeUtils-%{version}.tar.gz
BuildArch:	noarch
# Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(lib)
BuildRequires:	perl(Text::ParseWords)
# Run-time
BuildRequires:	perl(Carp)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(List::Util)
BuildRequires:	perl(Module::Implementation) >= 0.04
BuildRequires:	perl(strict)
BuildRequires:	perl(vars)
BuildRequires:	perl(warnings)
# Tests
BuildRequires:	perl(base)
BuildRequires:	perl(Config)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(overload)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(Storable)
BuildRequires:	perl(Test::Builder::Module)
BuildRequires:	perl(Test::LeakTrace)
BuildRequires:	perl(Test::More) >= 0.96
BuildRequires:	perl(Tie::Array)
# Optional Tests
BuildRequires:	perl(CPAN::Meta) >= 2.120900
BuildRequires:	perl(CPAN::Meta::Prereqs)
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
Requires:	perl(Carp)
# Can't require this due to bootstrapping requirements
%if 0%{?fedora} > 22 || 0%{?rhel} > 7
Recommends:	perl(List::SomeUtils::XS) >= 0.54
%endif

%description
List::SomeUtils provides some trivial but commonly needed functionality on
lists that is not going to go into List::Util.

%prep
%setup -q -n List-SomeUtils-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license LICENSE
%doc Changes CODE_OF_CONDUCT.md CONTRIBUTING.md README.md
%{perl_vendorlib}/List/
%{_mandir}/man3/List::SomeUtils.3*
%{_mandir}/man3/List::SomeUtils::PP.3*

%changelog
* Tue Jul 18 2023 Paul Howarth <paul@city-fan.org> - 0.59-2
- Drop MODULE_COMPAT dependency from Fedora 38 onwards

* Mon Dec 12 2022 Paul Howarth <paul@city-fan.org> - 0.59-1
- Update to 0.59
  - Require Module::Implementation 0.04; without this tests fail (GH#11)
- Use SPDX-format license tag
- Use %%license unconditionally

* Sun Oct 27 2019 Paul Howarth <paul@city-fan.org> - 0.58-1
- Update to 0.58
  BACKWARDS INCOMPATIBILITY
  - Fixed a number of bugs in the handling of empty lists
    - The any_u(), all_u(), none_u(), notall_u(), and one_u() functions
      returned an empty list in list context instead of undef, which is in
      direct opposition to the documentation, which has always said that it
      returned undef; note that the List::SomeUtils::XS code had the _correct_
      behaviour, so most users probably have never experienced this bug
  IMPROVEMENTS
  - Fixed some documentation issues (GH#7)
- Package CODE_OF_CONDUCT.md

* Fri Jun  7 2019 Paul Howarth <paul@city-fan.org> - 0.56-7
- Perl 5.30 rebuild

* Mon Jul 24 2017 Paul Howarth <paul@city-fan.org> - 0.56-1
- Update to 0.56
  - Fixed incorrect comments in doc examples for uniq()
  - Added a new function, mode() (GH#2)
  - Make sure we depend on the latest LSU::XS if the system supports XS
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl

* Fri Jun  2 2017 Paul Howarth <paul@city-fan.org> - 0.54-1
- Update to 0.54
  - Moved issue tracking to GitHub
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - Drop workaround for building with Test::More < 0.96

* Mon Aug 15 2016 Paul Howarth <paul@city-fan.org> - 0.53-1
- Update to 0.53
  - Replaced Exporter::Tiny with Exporter

* Wed Jun 29 2016 Paul Howarth <paul@city-fan.org> - 0.52-3
- Import from Fedora

* Sun May 15 2016 Jitka Plesnikova <jplesnik@redhat.com> - 0.52-2
- Perl 5.24 rebuild

* Mon May 09 2016 Jitka Plesnikova <jplesnik@redhat.com> - 0.52-1
- 0.52 bump

* Mon Mar 07 2016 Jitka Plesnikova <jplesnik@redhat.com> - 0.51-1
- Initial release
